

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Resource Management Ring Accelerator TISCI Message Description &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../../index.html"/>
        <link rel="up" title="Chapter 2: TISCI Message Documentation" href="../index.html"/>
        <link rel="next" title="Resource Management UDMAP TISCI Message Description" href="rm_udmap.html"/>
        <link rel="prev" title="Resource Management Proxy TISCI Message Description" href="rm_proxy.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                11.00.04
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Chapter 2: TISCI Message Documentation</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../general/TISCI_header.html">Texas Instruments System Controller Interface (TISCI)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#general">General</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#power-management-pm">Power Management (PM)</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../index.html#resource-management-rm">Resource Management (RM)</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="rm_irq.html">Resource Management IRQ TISCI Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="rm_proxy.html">Resource Management Proxy TISCI Message Description</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Resource Management Ring Accelerator TISCI Message Description</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#tisci-msg-rm-ring-cfg-ring-accelerator-ring-configure">TISCI_MSG_RM_RING_CFG - Ring Accelerator Ring Configure</a></li>
<li class="toctree-l4"><a class="reference internal" href="#tisci-msg-rm-ring-mon-cfg-ring-monitor-configuration">TISCI_MSG_RM_RING_MON_CFG - Ring Monitor Configuration</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ring-reset-procedure">Ring Reset Procedure</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="rm_udmap.html">Resource Management UDMAP TISCI Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="rm_psil.html">Resource Management PSI-L TISCI Message Description</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#secure-management">Secure Management</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../index.html">Chapter 2: TISCI Message Documentation</a> &raquo;</li>
      
    <li>Resource Management Ring Accelerator TISCI Message Description</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="resource-management-ring-accelerator-tisci-message-description">
<h1>Resource Management Ring Accelerator TISCI Message Description<a class="headerlink" href="#resource-management-ring-accelerator-tisci-message-description" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This chapter provides information on usage of the RM Ring Accelerator management
TISCI message API parameters.</p>
<table border="1" class="docutils">
<colgroup>
<col width="19%" />
<col width="81%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">TISCI Message ID</th>
<th class="head">Message Name</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>0x1100</td>
<td>RESERVED, DO NOT (RE)USE</td>
</tr>
<tr class="row-odd"><td>0x1101</td>
<td>RESERVED, DO NOT (RE)USE</td>
</tr>
<tr class="row-even"><td>0x1102</td>
<td>RESERVED, DO NOT (RE)USE</td>
</tr>
<tr class="row-odd"><td>0x1103</td>
<td>RESERVED, DO NOT (RE)USE</td>
</tr>
<tr class="row-even"><td>0x1110</td>
<td><a class="reference internal" href="#pub-rm-public-ra-cfg"><span class="std std-ref">TISCI_MSG_RM_RING_CFG</span></a></td>
</tr>
<tr class="row-odd"><td>N/A</td>
<td><a class="reference internal" href="#pub-rm-public-ra-cfg-response"><span class="std std-ref">TISCI_MSG_RM_RING_CFG Response</span></a></td>
</tr>
<tr class="row-even"><td>0x1111</td>
<td>RESERVED, DO NOT (RE)USE</td>
</tr>
<tr class="row-odd"><td>0x1120</td>
<td><a class="reference internal" href="#pub-rm-public-ra-mon-cfg"><span class="std std-ref">TISCI_MSG_RM_RING_MON_CFG</span></a></td>
</tr>
<tr class="row-even"><td>N/A</td>
<td><a class="reference internal" href="#pub-rm-public-ra-mon-cfg-response"><span class="std std-ref">TISCI_MSG_RM_RING_MON_CFG Response</span></a></td>
</tr>
</tbody>
</table>
<div class="section" id="ring-valid-parameters-field-usage">
<span id="pub-rm-public-ra-valid-params"></span><h3>Ring Valid Parameters Field Usage<a class="headerlink" href="#ring-valid-parameters-field-usage" title="Permalink to this headline">¶</a></h3>
<p>Some ring TISCI message APIs make use of a valid_params bit field.  Bits within
the valid_params field define whether or not individual TISCI message
parameters are valid.  When a bit corresponding to a parameter is set (to 1)
the parameter is considered valid and will be programmed into its
corresponding register field, assuming validation of the parameter passes.
When a valid_params bit is not set, i.e. a value of 0, the corresponding
register field is read and used within the validation process of the request.
The register field for a parameter is not programmed if the corresponding
valid_params bit is not set.</p>
</div>
</div>
<div class="section" id="tisci-msg-rm-ring-cfg-ring-accelerator-ring-configure">
<h2>TISCI_MSG_RM_RING_CFG - Ring Accelerator Ring Configure<a class="headerlink" href="#tisci-msg-rm-ring-cfg-ring-accelerator-ring-configure" title="Permalink to this headline">¶</a></h2>
<div class="section" id="ring-accelerator-ring-configure-request">
<span id="pub-rm-public-ra-cfg"></span><h3>Ring Accelerator Ring Configure Request<a class="headerlink" href="#ring-accelerator-ring-configure-request" title="Permalink to this headline">¶</a></h3>
<p>The <strong>ring cfg</strong> TISCI message API is used to configure SoC
Navigator Subsystem Ring Accelerator rings. The API only allows configuration
of a ring by passing the ring index and the Navigator SoC device ID in which the
ring is located.  Only the non-real-time ring registers are programmed as part
of the ring configuration. The host is granted access to the ring real-time
registers via the SoC channelized firewalls based on the RM board configuration.
The OS can access the ring real-time registers directly after ring configuration
is complete.</p>
<p>Ring ISC Virt IDs are programmable through the <strong>ring cfg</strong> TISCI message.
Host access permissions to program the ring Virt IDs are granted through the RM
board configuration.  A host attempting to program the Virt ID must be assigned
a Virt ID range and own, or be a supervisor of the owner of, the ring as
defined in the board configuration.  Virt IDs are typically programmed
by hypervisor.  Subordinates of the hypervisor are assigned and configure rings.
The hypervisor programs the ring’s Virt IDs separately (or at the same time if
the hypervisor is tasked with configuring a ring’s non-real-time registers as
well).</p>
<p>Ring parameter validation steps are performed against passed valid configuration
parameters in combination with existing register settings for configuration
parameters specified as not valid.</p>
<p>The ring global error event and per-ring event registers are not programmed as
part of the <strong>ring cfg</strong> API. These registers are decoupled from ring
configuration for security reasons. They’re programmed internally via
the <a class="reference internal" href="rm_irq.html#pub-rm-irq-route-set"><span class="std std-ref">RM IRQ Set</span></a> message.</p>
<p>The <strong>ring cfg</strong> TISCI message API resets the ring if any of the RING_BA_HI,
RING_BA_LO, or RING_SIZE registers are written as part of the ring
configuration.  Resetting a ring resets the ring’s occupancies and pointers.
The host, or a supervisor of the host, who owns the ring must be the
requesting host.</p>
<p>The <strong>ring cfg</strong> API can be used to configure rings within any Navigator
Subsystem Ring Accelerator on the device.</p>
<div class="section" id="usage">
<h4>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>No</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="tisci-message-id">
<h4>TISCI Message ID<a class="headerlink" href="#tisci-message-id" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_RM_RING_CFG</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x1110U)</span></code></p>
<p>RM TISCI message to configure a Navigator Subsystem ring</p>
</p>
</div>
<div class="section" id="ring-configure-message-parameters">
<h4>Ring Configure Message Parameters<a class="headerlink" href="#ring-configure-message-parameters" title="Permalink to this headline">¶</a></h4>
<p><p><strong>struct tisci_msg_rm_ring_cfg_req</strong></p>
<p>Configures a Navigator Subsystem ring</p>
<table border="1" class="docutils">
<colgroup>
<col width="2%" />
<col width="3%" />
<col width="95%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
<tr class="row-odd"><td>valid_params</td>
<td>u32</td>
<td>Bitfield defining validity of ring configuration parameters.  The ring configuration fields are not valid, and will not be used for ring configuration, if their corresponding valid bit is zero.  Valid bit usage: 0 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::addr_lo 1 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::addr_hi 2 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::count 3 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::mode 4 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::size 5 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::order_id 6 - Valid bit for &#64;ref tisci_msg_rm_ring_cfg_req::virtid</td>
</tr>
<tr class="row-even"><td>nav_id</td>
<td>u16</td>
<td>SoC device ID of Navigator Subsystem where ring is located</td>
</tr>
<tr class="row-odd"><td>index</td>
<td>u16</td>
<td>Ring index.</td>
</tr>
<tr class="row-even"><td>addr_lo</td>
<td>u32</td>
<td>32 LSBs of ring base address to be programmed into the ring’s RING_BA_LO register.</td>
</tr>
<tr class="row-odd"><td>addr_hi</td>
<td>u32</td>
<td>16 MSBs of ring base address to be programmed into the ring’s RING_BA_HI register.  Only the 16 LSBs of &#64;ref addr_hi are used when programming RING_BA_HI, the upper 16 bits are discarded.</td>
</tr>
<tr class="row-even"><td>count</td>
<td>u32</td>
<td>Number of ring elements to be programmed into the size field of the ring’s RING_SIZE register.</td>
</tr>
<tr class="row-odd"><td>mode</td>
<td>u8</td>
<td>Ring mode to be programmed into the qmode field of the ring’s RING_SIZE register.  Can be set to: &#64;ref TISCI_MSG_VALUE_RM_RING_MODE_RING &#64;ref TISCI_MSG_VALUE_RM_RING_MODE_MESSAGE &#64;ref TISCI_MSG_VALUE_RM_RING_MODE_CREDENTIALS &#64;ref TISCI_MSG_VALUE_RM_RING_MODE_QM</td>
</tr>
<tr class="row-even"><td>size</td>
<td>u8</td>
<td>Encoded ring element size to be programmed into the elsize field of the ring’s RING_SIZE register.  To calculate the encoded size use the formula (log2(size_bytes) - 2), where “size_bytes” cannot be greater than 256 bytes.  Can be set to: &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_4B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_8B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_16B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_32B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_64B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_128B &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_256B</td>
</tr>
<tr class="row-odd"><td>order_id</td>
<td>u8</td>
<td>Ring bus order ID value to be programmed into the orderid field of the ring’s RING_ORDERID register.  When valid, the replace field of the ring’s RING_ORDERID register will be set to 1 so that the programmed order ID will be used.</td>
</tr>
<tr class="row-even"><td>virtid</td>
<td>u16</td>
<td>Ring virt ID value to be programmed into the virtid field of the ring’s RING_CONTROL2 ISC region register.  This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_RING_VIRTID_VALID is set in &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.</td>
</tr>
<tr class="row-odd"><td>asel</td>
<td>u8</td>
<td>Ring ASEL (address select) value to be set into the ASEL field of the ring’s RING_BA_HI register.  This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_RING_ASEL_VALID is set in &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.  This field is not supported on some SoCs.  On SoCs that do not support this field the input is quietly ignored even if the valid bit is set.</td>
</tr>
</tbody>
</table>
<p>Configures the non-real-time registers of a Navigator Subsystem ring.
 The ring index must be assigned to the host defined in the TISCI header via
 the RM board configuration resource assignment range list.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_ADDR_LO_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_ADDR_HI_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_COUNT_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_MODE_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_SIZE_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.
 This field is only valid if
 &#64;ref TISCI_MSG_VALUE_RM_RING_ORDER_ID_VALID is set in
 &#64;ref tisci_msg_rm_ring_cfg_req::valid_params.</p>
</p>
</div>
<div class="section" id="ring-configuration-valid-parameters">
<span id="pub-rm-ring-cfg-valid-params"></span><h4>Ring Configuration Valid Parameters<a class="headerlink" href="#ring-configuration-valid-parameters" title="Permalink to this headline">¶</a></h4>
<p>The following table describes the valid bit mappings for the ring configure
message optional parameters:</p>
<table border="1" class="docutils">
<colgroup>
<col width="23%" />
<col width="77%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">valid_params Bit</th>
<th class="head">Corresponding tisci_msg_rm_ring_cfg_req Optional Parameter</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>0</td>
<td>addr_lo</td>
</tr>
<tr class="row-odd"><td>1</td>
<td>addr_hi</td>
</tr>
<tr class="row-even"><td>2</td>
<td>count</td>
</tr>
<tr class="row-odd"><td>3</td>
<td>mode</td>
</tr>
<tr class="row-even"><td>4</td>
<td>size</td>
</tr>
<tr class="row-odd"><td>5</td>
<td>order_id</td>
</tr>
<tr class="row-even"><td>6</td>
<td>virtid</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="section" id="ring-accelerator-ring-configure-response">
<span id="pub-rm-public-ra-cfg-response"></span><h3>Ring Accelerator Ring Configure Response<a class="headerlink" href="#ring-accelerator-ring-configure-response" title="Permalink to this headline">¶</a></h3>
<p>The <strong>ring cfg response</strong> message returns the result status of the
processed <strong>ring cfg</strong> message.</p>
<div class="section" id="ring-configure-response-message-parameters">
<h4>Ring Configure Response Message Parameters<a class="headerlink" href="#ring-configure-response-message-parameters" title="Permalink to this headline">¶</a></h4>
<p><p><strong>struct tisci_msg_rm_ring_cfg_resp</strong></p>
<p>Response to configuring a ring.</p>
<table border="1" class="docutils">
<colgroup>
<col width="23%" />
<col width="37%" />
<col width="40%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
</div>
<div class="section" id="tisci-msg-rm-ring-mon-cfg-ring-monitor-configuration">
<h2>TISCI_MSG_RM_RING_MON_CFG - Ring Monitor Configuration<a class="headerlink" href="#tisci-msg-rm-ring-mon-cfg-ring-monitor-configuration" title="Permalink to this headline">¶</a></h2>
<div class="section" id="ring-monitor-configuration-request">
<span id="pub-rm-public-ra-mon-cfg"></span><h3>Ring Monitor Configuration Request<a class="headerlink" href="#ring-monitor-configuration-request" title="Permalink to this headline">¶</a></h3>
<p>The <strong>ring_mon_cfg</strong> TISCI message API is used to configures the real-time
registers of a Navigator Subsystem ring monitor.  The ring monitor
index must be assigned to the host defined in the TISCI header via the RM
board configuration resource assignment range list.  The channelized
firewalls covering the ring monitor registers are configured to allow the
host read-only access.</p>
<div class="section" id="id1">
<h4>Usage<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>No</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id2">
<h4>TISCI Message ID<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_RM_RING_MON_CFG</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x1120U)</span></code></p>
<p>RM TISCI message to configure a Navigator Subsystem ring monitor</p>
</p>
</div>
<div class="section" id="ring-monitor-configuration-message-parameters">
<h4>Ring Monitor Configuration Message Parameters<a class="headerlink" href="#ring-monitor-configuration-message-parameters" title="Permalink to this headline">¶</a></h4>
<p><p><strong>struct tisci_msg_rm_ring_mon_cfg_req</strong></p>
<p>Configures a Navigator Subsystem ring monitor.  Configures the real-time registers of a Navigator Subsystem ring monitor.  The ring monitor index must be assigned to the host defined in the TISCI header via the RM board configuration resource assignment range list.  The channelized firewalls covering the ring monitor registers are configured to allow the host read-only access.</p>
<table border="1" class="docutils">
<colgroup>
<col width="2%" />
<col width="4%" />
<col width="94%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
<tr class="row-odd"><td>valid_params</td>
<td>u32</td>
<td>Bitfield defining validity of ring monitor configuration parameters.  The ring monitor configuration fields are not valid, and will not be used for ring monitor configuration, if their corresponding valid bit is zero.  Valid bit usage: 0 - Valid bit for &#64;ref tisci_msg_rm_ring_mon_cfg_req::source 1 - Valid bit for &#64;ref tisci_msg_rm_ring_mon_cfg_req::mode 2 - Valid bit for &#64;ref tisci_msg_rm_ring_mon_cfg_req::queue 3 - Valid bit for &#64;ref tisci_msg_rm_ring_mon_cfg_req::data0_val 4 - Valid bit for &#64;ref tisci_msg_rm_ring_mon_cfg_req::data1_val</td>
</tr>
<tr class="row-even"><td>nav_id</td>
<td>u16</td>
<td>SoC device ID of Navigator Subsystem where ring monitor is located</td>
</tr>
<tr class="row-odd"><td>index</td>
<td>u16</td>
<td>Ring monitor index.</td>
</tr>
<tr class="row-even"><td>source</td>
<td>u8</td>
<td>Monitor source selection programmed into RINGACC_CONTROL register.  Can be set to: &#64;ref TISCI_MSG_VALUE_RM_MON_SRC_ELEM_CNT &#64;ref TISCI_MSG_VALUE_RM_MON_SRC_HEAD_PKT_SIZE &#64;ref TISCI_MSG_VALUE_RM_MON_SRC_ACCUM_Q_SIZE This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_MON_SOURCE_VALID is set in &#64;ref tisci_msg_rm_ring_mon_cfg_req::valid_params.</td>
</tr>
<tr class="row-odd"><td>mode</td>
<td>u8</td>
<td>Monitor mode programmed into RINGACC_CONTROL register.  Can be set to: &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_DISABLED &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_PUSH_POP &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_THRESHOLD &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_WATERMARK &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_STARVATION This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_MON_MODE_VALID is set in &#64;ref tisci_msg_rm_ring_mon_cfg_req::valid_params.</td>
</tr>
<tr class="row-even"><td>queue</td>
<td>u16</td>
<td>Queue, or ring, to monitor programmed into RINGACC_QUEUE register.  The specified queue must be assigned to the host, or a subordinate of the host, requesting the ring monitor configuration. This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_MON_QUEUE_VALID is set in &#64;ref tisci_msg_rm_ring_mon_cfg_req::valid_params.</td>
</tr>
<tr class="row-odd"><td>data0_val</td>
<td>u32</td>
<td>Low threshold value programmed into RINGACC_DATA0 register when the ring monitor mode is configured to low/high threshold checking.  Values specified in this field are ignored for other monitor modes. This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_MON_DATA0_VAL_VALID is set in &#64;ref tisci_msg_rm_ring_mon_cfg_req::valid_params.</td>
</tr>
<tr class="row-even"><td>data1_val</td>
<td>u32</td>
<td>High threshold value programmed into RINGACC_DATA1 register when the ring monitor mode is configured to low/high threshold checking.  Values specified in this field are ignored for other monitor modes. This field is only valid if &#64;ref TISCI_MSG_VALUE_RM_MON_DATA1_VAL_VALID is set in &#64;ref tisci_msg_rm_ring_mon_cfg_req::valid_params.</td>
</tr>
</tbody>
</table>
</p>
</div>
<div class="section" id="ring-monitor-configuration-valid-parameters">
<span id="pub-rm-public-ra-mon-cfg-valid-params"></span><h4>Ring Monitor Configuration Valid Parameters<a class="headerlink" href="#ring-monitor-configuration-valid-parameters" title="Permalink to this headline">¶</a></h4>
<p>The following table describes the valid bit mappings for the ring monitor
configuration parameters:</p>
<table border="1" class="docutils">
<colgroup>
<col width="24%" />
<col width="76%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">valid_params Bit</th>
<th class="head">Corresponding tisci_msg_rm_ring_mon_cfg_req Parameter</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>0</td>
<td>source</td>
</tr>
<tr class="row-odd"><td>1</td>
<td>mode</td>
</tr>
<tr class="row-even"><td>2</td>
<td>queue</td>
</tr>
<tr class="row-odd"><td>3</td>
<td>data0_val</td>
</tr>
<tr class="row-even"><td>4</td>
<td>data1_val</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="section" id="ring-monitor-configuration-response">
<span id="pub-rm-public-ra-mon-cfg-response"></span><h3>Ring Monitor Configuration Response<a class="headerlink" href="#ring-monitor-configuration-response" title="Permalink to this headline">¶</a></h3>
<p>The <strong>ring_mon_cfg_response</strong> message returns the result status of the
processed <strong>ring_mon_cfg</strong> message.</p>
<div class="section" id="ring-monitor-configuration-response-message-parameters">
<h4>Ring Monitor Configuration Response Message Parameters<a class="headerlink" href="#ring-monitor-configuration-response-message-parameters" title="Permalink to this headline">¶</a></h4>
<p><p><strong>struct tisci_msg_rm_ring_mon_cfg_resp</strong></p>
<p>Response to configuring a ring monitor.</p>
<table border="1" class="docutils">
<colgroup>
<col width="23%" />
<col width="37%" />
<col width="40%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
</div>
<div class="section" id="ring-reset-procedure">
<h2>Ring Reset Procedure<a class="headerlink" href="#ring-reset-procedure" title="Permalink to this headline">¶</a></h2>
<p id="pub-rm-public-ra-reset">This section describes the steps the OS needs to take in order to reset a
ring.</p>
<p>Generic reset procedure for most devices:</p>
<ol class="arabic simple">
<li>OS sends the <strong>ring cfg</strong> TISCI message modifying either RING_BA_HI,
RING_BA_LO, or RING_SIZE non-real-time registers to reset a ring.</li>
</ol>
<p>Some devices require a different ring reset procedure as defined by
ErrataID # i2023. The reset procedure synchronizes the occupancy count between
the UDMAP ring state and the RA ring state after the ring is reset. The
procedure is:</p>
<ol class="arabic simple">
<li>Read the ring occupancy (RINGACC_OCC_j [CNT]) as
“adjusted ring occupancy count” from the ring’s real-time registers<ul>
<li>If the ring is configured in credentials mode or queue manager (QM) mode,
adjust “adjusted ring occupancy count” by dividing the ring occupancy by 2.
This is required because when in credentials mode or QM mode, each ring
write increases the ring occupancy by 2 elements (one entry for the
credentials, one entry for the data).  However, the UDMAP’s local occupancy
counter only records the number of writes, and the ring occupancy,
therefore, needs to be divided by 2 to convert back to the number of
doorbell rings needed.</li>
<li>If the ring occupancy is not 0, then steps 2-5 need to be executed to
implement the workaround.</li>
</ul>
</li>
<li>Application directly reads the RINGACC CFG registers to retrieve the ring
qmode if not already in ring/doorbell mode.  Save the qmode if the original
mode was not ring/doorbell mode.</li>
<li>Reset the ring by writing any value to the ring’s RINGACC CFG registers
(i.e. enable the valid parameter bit for mode, size, or count in the
<strong>ring cfg</strong> TISCI message)</li>
<li>Send the <strong>ring cfg</strong> message to DMSC specifying qmode as ring/doorbell if
not already in that mode.</li>
<li>Ring the (doorbell 2**22 – (adjusted ring occupancy count)) through the
ring’s real-time registers. This will wrap the internal UDMAP ring state
occupancy counter (which is 21-bits wide) to 0. (If possible, ring the
doorbell with the maximum count each iteration to minimize the total number
of writes.)</li>
<li>Send the <strong>ring cfg</strong> message to DMSC to program qmode back to the
origin qmode (if not ring/doorbell mode).</li>
</ol>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="rm_udmap.html" class="btn btn-neutral float-right" title="Resource Management UDMAP TISCI Message Description" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="rm_proxy.html" class="btn btn-neutral" title="Resource Management Proxy TISCI Message Description" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2025</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'11.00.04',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>